/**
 * RTOPQPQ.java
 *
 * File generated from the datatypes::RTOPQPQ uml Class
 * Generated by IHE - europe, gazelle team
 */
package net.ihe.gazelle.ips.datatypes;

// End of user code
import java.util.List;

import javax.xml.bind.JAXBContext;
import javax.xml.bind.JAXBException;
import javax.xml.bind.Marshaller;
import javax.xml.bind.annotation.XmlAccessType;
import javax.xml.bind.annotation.XmlAccessorType;
import javax.xml.bind.annotation.XmlElement;
import javax.xml.bind.annotation.XmlRootElement;
import javax.xml.bind.annotation.XmlTransient;
import javax.xml.bind.annotation.XmlType;
import javax.xml.parsers.DocumentBuilder;
import javax.xml.parsers.DocumentBuilderFactory;
import javax.xml.parsers.ParserConfigurationException;

import net.ihe.gazelle.gen.common.ConstraintValidatorModule;

import org.w3c.dom.Document;
import org.w3c.dom.Node;


/**
 * Description of the class RTOPQPQ.
 *
 */

@XmlAccessorType(XmlAccessType.FIELD)
@XmlType(name = "RTO_PQ_PQ", propOrder = {
	"numerator",
	"denominator"
})
@XmlRootElement(name = "RTO_PQ_PQ")
public class RTOPQPQ extends net.ihe.gazelle.ips.datatypes.QTY implements java.io.Serializable {
	
	/**
	 * 
	 */
	private static final long serialVersionUID = 1L;

	
	/**
	 *  The quantity that is being divided in the ratio. The default is the integer number 1 (one). .
	 */
	@XmlElement(name = "numerator", required = true, namespace = "urn:hl7-org:v3")
	public net.ihe.gazelle.ips.datatypes.PQ numerator;
	/**
	 *  The quantity that devides the numerator in the ratio. The default is the integer number 1 (one). The denominator must not be zero. .
	 */
	@XmlElement(name = "denominator", required = true, namespace = "urn:hl7-org:v3")
	public net.ihe.gazelle.ips.datatypes.PQ denominator;
	
	/**
	 * An attribute containing marshalled element node
	 */
	@XmlTransient
	private Node _xmlNodePresentation;
	
	
	/**
	 * Return numerator.
	 * @return numerator :  The quantity that is being divided in the ratio. The default is the integer number 1 (one). 
	 */
	public net.ihe.gazelle.ips.datatypes.PQ getNumerator() {
	    return numerator;
	}
	
	/**
	 * Set a value to attribute numerator.
	 * @param numerator :  The quantity that is being divided in the ratio. The default is the integer number 1 (one). .
	 */
	public void setNumerator(net.ihe.gazelle.ips.datatypes.PQ numerator) {
	    this.numerator = numerator;
	}
	
	
	
	
	/**
	 * Return denominator.
	 * @return denominator :  The quantity that devides the numerator in the ratio. The default is the integer number 1 (one). The denominator must not be zero. 
	 */
	public net.ihe.gazelle.ips.datatypes.PQ getDenominator() {
	    return denominator;
	}
	
	/**
	 * Set a value to attribute denominator.
	 * @param denominator :  The quantity that devides the numerator in the ratio. The default is the integer number 1 (one). The denominator must not be zero. .
	 */
	public void setDenominator(net.ihe.gazelle.ips.datatypes.PQ denominator) {
	    this.denominator = denominator;
	}
	
	
	
	
	
	public Node get_xmlNodePresentation() {
		if (_xmlNodePresentation == null){
				JAXBContext jc;
				DocumentBuilderFactory dbf = DocumentBuilderFactory.newInstance();
				dbf.setNamespaceAware(true);
				DocumentBuilder db = null;
				Document doc = null;
				try {
					db = dbf.newDocumentBuilder();
					doc = db.newDocument();
				} catch (ParserConfigurationException e1) {}
				try {
					jc = JAXBContext.newInstance("net.ihe.gazelle.ips.datatypes");
					Marshaller m = jc.createMarshaller();
					m.marshal(this, doc);
					_xmlNodePresentation = doc.getElementsByTagNameNS("urn:hl7-org:v3", "RTO_PQ_PQ").item(0);
				} catch (JAXBException e) {
					try{
						db = dbf.newDocumentBuilder();
						_xmlNodePresentation = db.newDocument();
					}
					catch(Exception ee){}
				}
			}
			return _xmlNodePresentation;
	}
	
	public void set_xmlNodePresentation(Node _xmlNodePresentation) {
		this._xmlNodePresentation = _xmlNodePresentation;
	}
	
	
	

	
	/**
     * validate by a module of validation
     * 
     */
   public static void validateByModule(RTOPQPQ rTOPQPQ, String _location, ConstraintValidatorModule cvm, List<net.ihe.gazelle.validation.Notification> diagnostic){
   		if (rTOPQPQ != null){
   			net.ihe.gazelle.ips.datatypes.QTY.validateByModule(rTOPQPQ, _location, cvm, diagnostic);
			net.ihe.gazelle.ips.datatypes.PQ.validateByModule(rTOPQPQ.getNumerator(), _location + "/numerator", cvm, diagnostic);
			net.ihe.gazelle.ips.datatypes.PQ.validateByModule(rTOPQPQ.getDenominator(), _location + "/denominator", cvm, diagnostic);
    	}
    }

}